USE AdventureWorks2012;
SET NOCOUNT ON;
GO

-- Run this query against AdventureWorks2012
-- Will work on 2008/2008 R2 as well; not 2005

-- OPTION (RECOMPILE) is important!

SELECT * FROM Sales.SalesOrderHeader AS h
  INNER JOIN Sales.SalesOrderDetail AS d
  ON h.SalesOrderID = d.SalesOrderID
  ORDER BY CustomerID
  OPTION (RECOMPILE);

-- Pretend we have 64 CPUs and 1 TB of RAM:

DBCC OPTIMIZER_WHATIF(CPUs, 64) WITH NO_INFOMSGS;
DBCC OPTIMIZER_WHATIF(MemoryMBs, 1048576) WITH NO_INFOMSGS;
DBCC OPTIMIZER_WHATIF(Status) WITH NO_INFOMSGS;

-- Now run the above query again, see parallelism

-- Simulate MAXDOP 1 without changing the statement
-- or using Resource Governor or server-wide setting:

DBCC OPTIMIZER_WHATIF(CPUs, 1) WITH NO_INFOMSGS;

-- Put things back to normal:

DBCC OPTIMIZER_WHATIF(ResetAll) WITH NO_INFOMSGS;