USE AdventureWorks2012;
SET NOCOUNT ON;
GO

-- three simple tables, with different column sizes:
CREATE TABLE dbo.test_max (id INT, x VARCHAR(MAX));
CREATE TABLE dbo.test_8000(id INT, x VARCHAR(8000));
CREATE TABLE dbo.test_255 (id INT, x VARCHAR(255));

-- populate them all with the same data:
INSERT dbo.test_max (id,x) SELECT object_id, name FROM sys.all_columns;
INSERT dbo.test_8000(id,x) SELECT object_id, name FROM sys.all_columns;
INSERT dbo.test_255 (id,x) SELECT object_id, name FROM sys.all_columns;

-- check the estimated data size for these three queries in Plan Explorer:
SELECT id,x FROM dbo.test_max
UNION ALL
SELECT id,x FROM dbo.test_8000
UNION ALL
SELECT id,x FROM dbo.test_255;

-- clean up:
DROP TABLE dbo.test_max, dbo.test_8000, dbo.test_255;