USE AdventureWorks2012;
SET NOCOUNT ON;
GO

CREATE TABLE dbo.MyTable(id INT);
GO

INSERT dbo.MyTable VALUES(1),(4);
GO

CREATE TRIGGER dbo.MyTable_All
 ON dbo.MyTable
 FOR INSERT, UPDATE, DELETE
AS
BEGIN
  PRINT 'Executing ALL trigger. Row count: ' + RTRIM(@@ROWCOUNT);
  
  IF EXISTS (SELECT 1 FROM inserted) AND NOT EXISTS (SELECT 1 FROM deleted)
  BEGIN
    PRINT '  I am an insert...';
  END
  IF EXISTS (SELECT 1 FROM inserted) AND EXISTS (SELECT 1 FROM deleted)
  BEGIN
    PRINT '  I am an update...';
  END
  IF NOT EXISTS (SELECT 1 FROM inserted) AND EXISTS (SELECT 1 FROM deleted)
  BEGIN
    PRINT '  I am a delete...';
  END
END
GO

CREATE TRIGGER dbo.MyTable_INSERTOnly
 ON dbo.MyTable
 FOR INSERT
AS
BEGIN
  PRINT 'INSERT only trigger fired. Row count: ' + RTRIM(@@ROWCOUNT);
END
GO

MERGE dbo.MyTable WITH (HOLDLOCK) AS [Target]
USING (VALUES(1),(2),(3)) AS [Source](id)
ON [Target].id = [Source].id
WHEN MATCHED THEN UPDATE SET [Target].id = [Source].id
WHEN NOT MATCHED THEN INSERT(id) VALUES([Source].id)
WHEN NOT MATCHED BY SOURCE THEN DELETE;
GO

DROP TABLE dbo.MyTable;