USE AdventureWorks2012;
SET NOCOUNT ON;
GO

CREATE FUNCTION dbo.SplitStrings_XML
(
   @List       NVARCHAR(MAX),
   @Delimiter  NVARCHAR(255)
)
RETURNS TABLE
WITH SCHEMABINDING
AS
   RETURN 
   (  
      SELECT Item = y.i.value('(./text())[1]', 'nvarchar(4000)')
      FROM 
      ( 
        SELECT x = CONVERT(XML, '<i>' 
          + REPLACE(@List, @Delimiter, '</i><i>') 
          + '</i>').query('.')
      ) AS a CROSS APPLY x.nodes('i') AS y(i)
   );
GO

CREATE TYPE dbo.LastNames AS TABLE(LastName NVARCHAR(50) PRIMARY KEY);

-- compare these in Plan Explorer:

DECLARE @LastNames NVARCHAR(MAX) = N'Jai,Ward,Baker,Sanders,Prasad,Bertrand';

SELECT p.BusinessEntityID, p.FirstName, p.LastName, p.PersonType
FROM Person.Person AS p
INNER JOIN dbo.SplitStrings_XML(@LastNames, ',') AS s
ON p.LastName = s.Item;
GO

DECLARE @LastNames dbo.LastNames;
INSERT @LastNames VALUES(N'Jai'),(N'Ward'),(N'Baker'),(N'Sanders'),(N'Prasad'),(N'Bertrand');

SELECT p.BusinessEntityID, p.FirstName, p.LastName, p.PersonType
FROM Person.Person AS p
INNER JOIN @LastNames AS l
ON p.LastName = l.LastName;


DROP FUNCTION dbo.SplitStrings_XML;
DROP TYPE dbo.LastNames;