USE AdventureWorks2014;
SET NOCOUNT ON;
GO

-- CTE is not a #temp table. 
-- Underlying table can be scanned twice:

;WITH x AS (SELECT LastName FROM Person.Person)
SELECT LastName FROM x
UNION ALL
SELECT LastName FROM x;

-- Remove duplicates using a CTE:

CREATE TABLE #x(name SYSNAME);

INSERT #x VALUES(N'Bob'),(N'Frank'),(N'Bob'),(N'Sam'),(N'Bob'),(N'Sam');

;WITH x AS (SELECT name, rn = ROW_NUMBER() OVER (PARTITION BY name ORDER BY name)
  FROM #x
)
--DELETE x WHERE rn > 1;
SELECT name, rn FROM x;

SELECT name FROM #x;

-- now, add a constraint, of course!

DROP TABLE #x;



