-- anyone using compat_levels?
SELECT [name], [compatibility_level]
FROM sys.[databases];


-- works on 80 & 90, fails on 100 & 120.
-- keyword with the new MERGE DML statement
SELECT merge = 1; 
GO

SELECT 'merge' = 1;
GO


-- From Kendra Little, in the article https://www.brentozar.com/archive/2014/04/sql-2014-cardinality-estimator-eats-bad-tsql-breakfast/

USE AdventureWorks2014;
GO

/*
-- Optionally enable the new CE at the query level
OPTION (QUERYTRACEON 2312) 

DBCC TRACEON(2312) -- enables the new CE, at the session level
DBCC TRACEON(9481) -- disables the new CE, at the session level
-- Use format (-1, xxxx) to enable/disable at the server level

-- at the database level
ALTER DATABASE AdventureWorks2014 SET COMPATIBILITY_LEVEL = 120; -- SQL Server 2014 compatibility level
ALTER DATABASE [AdventureWorks2014] SET COMPATIBILITY_LEVEL = 110; -- SQL Server 2012 compatibility level
GO
*/

SELECT e.[BusinessEntityID],
       p.[Title], p.[FirstName], p.[MiddleName], p.[LastName], p.[Suffix],     
	   e.[JobTitle], pp.[PhoneNumber], pnt.[Name] AS [PhoneNumberType],
       ea.[EmailAddress], p.[EmailPromotion],
       a.[AddressLine1], a.[AddressLine2], a.[City],
       sp.[Name] AS [StateProvinceName], a.[PostalCode],
       cr.[Name] AS [CountryRegionName],
       p.[AdditionalContactInfo]
FROM   [HumanResources].[Employee] AS e
       INNER JOIN [Person].[Person] AS p
       ON RTRIM(LTRIM(p.[BusinessEntityID])) = RTRIM(LTRIM(e.[BusinessEntityID]))
       INNER JOIN [Person].[BusinessEntityAddress] AS bea
       ON RTRIM(LTRIM(bea.[BusinessEntityID])) = RTRIM(LTRIM(e.[BusinessEntityID]))
       INNER JOIN [Person].[Address] AS a
       ON RTRIM(LTRIM(a.[AddressID])) = RTRIM(LTRIM(bea.[AddressID]))
       INNER JOIN [Person].[StateProvince] AS sp
       ON RTRIM(LTRIM(sp.[StateProvinceID])) = RTRIM(LTRIM(a.[StateProvinceID]))
       INNER JOIN [Person].[CountryRegion] AS cr
       ON RTRIM(LTRIM(cr.[CountryRegionCode])) = RTRIM(LTRIM(sp.[CountryRegionCode]))
       LEFT OUTER JOIN [Person].[PersonPhone] AS pp
       ON RTRIM(LTRIM(pp.BusinessEntityID)) = RTRIM(LTRIM(p.[BusinessEntityID]))
       LEFT OUTER JOIN [Person].[PhoneNumberType] AS pnt
       ON RTRIM(LTRIM(pp.[PhoneNumberTypeID])) = RTRIM(LTRIM(pnt.[PhoneNumberTypeID]))
       LEFT OUTER JOIN [Person].[EmailAddress] AS ea
       ON RTRIM(LTRIM(p.[BusinessEntityID])) = RTRIM(LTRIM(ea.[BusinessEntityID]));
GO

/* 
-- Puts the entire database at compat_level 110
ALTER DATABASE AdventureWorks2014 SET COMPATIBILITY_LEVEL=110;
GO
*/

-- Option Hint sets compat_level only for the specified query
SELECT e.[BusinessEntityID],
       p.[Title], p.[FirstName], p.[MiddleName], p.[LastName], p.[Suffix],     
	   e.[JobTitle], pp.[PhoneNumber], pnt.[Name] AS [PhoneNumberType],
       ea.[EmailAddress], p.[EmailPromotion],
       a.[AddressLine1], a.[AddressLine2], a.[City],
       sp.[Name] AS [StateProvinceName], a.[PostalCode],
       cr.[Name] AS [CountryRegionName],
       p.[AdditionalContactInfo]
FROM   [HumanResources].[Employee] AS e
       INNER JOIN [Person].[Person] AS p
       ON RTRIM(LTRIM(p.[BusinessEntityID])) = RTRIM(LTRIM(e.[BusinessEntityID]))
       INNER JOIN [Person].[BusinessEntityAddress] AS bea
       ON RTRIM(LTRIM(bea.[BusinessEntityID])) = RTRIM(LTRIM(e.[BusinessEntityID]))
       INNER JOIN [Person].[Address] AS a
       ON RTRIM(LTRIM(a.[AddressID])) = RTRIM(LTRIM(bea.[AddressID]))
       INNER JOIN [Person].[StateProvince] AS sp
       ON RTRIM(LTRIM(sp.[StateProvinceID])) = RTRIM(LTRIM(a.[StateProvinceID]))
       INNER JOIN [Person].[CountryRegion] AS cr
       ON RTRIM(LTRIM(cr.[CountryRegionCode])) = RTRIM(LTRIM(sp.[CountryRegionCode]))
       LEFT OUTER JOIN [Person].[PersonPhone] AS pp
       ON RTRIM(LTRIM(pp.BusinessEntityID)) = RTRIM(LTRIM(p.[BusinessEntityID]))
       LEFT OUTER JOIN [Person].[PhoneNumberType] AS pnt
       ON RTRIM(LTRIM(pp.[PhoneNumberTypeID])) = RTRIM(LTRIM(pnt.[PhoneNumberTypeID]))
       LEFT OUTER JOIN [Person].[EmailAddress] AS ea
       ON RTRIM(LTRIM(p.[BusinessEntityID])) = RTRIM(LTRIM(ea.[BusinessEntityID]))
OPTION(QUERYTRACEON 9481);


-- Simple cardinality estimation error in pre-2014 versions
-- Legacy
SELECT	[AddressID],
	[AddressLine1],
	[AddressLine2]
FROM Person.[Address]
WHERE [StateProvinceID] = 9 AND
	[City] = 'Burbank'
OPTION (QUERYTRACEON 2312);

-- New CE
SELECT	[AddressID],
	[AddressLine1],
	[AddressLine2]
FROM Person.[Address]
WHERE [StateProvinceID] = 9 AND
	[City] = 'Burbank'
OPTION (QUERYTRACEON 9481);
GO



/*
-- works on 80 & 90, fails on 100 & 120
SELECT merge = 1; -- Keyword with the new MERGE DML statement
GO

SELECT 'merge' =1;
GO

-- works on 80, fails on 90 & 100
-- different error message on 2014, even in 100
SELECT TOP (1) o.name
  FROM sys.objects AS o,
       sys.columns AS c
  WHERE o.[object_id] *= c.[object_id]
  ORDER BY o.name;

-- works on 90+
SELECT * FROM 
  sys.dm_db_index_physical_stats(DB_ID(), NULL, NULL, NULL, NULL);
*/