USE AdventureWorks2012;
SET NOCOUNT ON;
GO

-- Start a TXN that takes Sch-M and/or Sch-S locks:

BEGIN TRANSACTION;
ALTER TABLE dbo.ErrorLog ADD foo INT;

-- Now run this batch in another window:
      SET TRANSACTION ISOLATION LEVEL READ UNCOMMITTED;
      
      -- blocked! Does not obey isolation semantics
      SELECT OBJECT_SCHEMA_NAME(o.[object_id]) 
        FROM sys.objects AS o
        WHERE o.name = N'ErrorLog';
      
      -- works! Obeys isolation semantics
      SELECT s.name 
        FROM sys.objects AS o
        INNER JOIN sys.schemas AS s
          ON o.[schema_id] = s.[schema_id]
        WHERE o.name = N'ErrorLog';

-- clean up:
ROLLBACK TRANSACTION;